// This is the code for the main CPX.
#define BLYNK_PRINT SerialUSB
// #define BLYNK_DEBUG SerialUSB

// Here copy you Blynk info

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <Adafruit_CircuitPlayground.h>

char auth[] = BLYNK_AUTH_TOKEN;
// Here insert your network name and password:
char ssid[] = ;
char pass[] = ;

bool switch_status;
bool enable_phone_using_sensor = false;

#define EspSerial Serial1
#define ESP8266_BAUD 115200

ESP8266 wifi(&EspSerial);

void setup() {
  CircuitPlayground.begin();
  SerialUSB.begin(115200);
  EspSerial.begin(ESP8266_BAUD);
  delay(10);
  Blynk.begin(auth, wifi, ssid, pass);
  CircuitPlayground.setPixelColor(9, 0x00FF00);  
  bool switch_status = CircuitPlayground.slideSwitch();
}

void loop() {
  Blynk.run();
  // In case the listner is active and a case where the phone was lifted occured - activate the action function.
  if(enable_phone_using_sensor && CircuitPlayground.lightSensor() > 5){
    action();
  }
  // Activate and decativate the "Using phone while studying" case listner.
  if(CircuitPlayground.leftButton() || CircuitPlayground.rightButton()){
    enable_phone_using_sensor = !enable_phone_using_sensor;
    CircuitPlayground.setPixelColor(9, 0x0000FF);  
    if(enable_phone_using_sensor == true){
      CircuitPlayground.setPixelColor(8, 0x0000FF);        
    }
    delay(10000);
    CircuitPlayground.clearPixels();
    CircuitPlayground.setPixelColor(9, 0x00FF00); 
  }
  delay(10000);
}

// Make calls to the blynk to trigger integromat.
void action(){
  CircuitPlayground.setPixelColor(9, 0xFF0000);
  Blynk.virtualWrite(V0, 1);
  delay(10000);
  CircuitPlayground.setPixelColor(9, 0x00FF00);  
}

// Alarm clock function
void alarm_clock(){
  for(int i = 0; i < 3; i++){
    for (int i = 0; i < 3; i++) {
      CircuitPlayground.playTone(800, 30);
      delay(50);  
    }
    delay(100);
  }
}

// If a writing to Blynk's v1 is detected - activate alarm clock
BLYNK_WRITE(V1) {
  Blynk.virtualWrite(V1,0); 
  CircuitPlayground.setPixelColor(9, 0xFF0000);
  while(switch_status == CircuitPlayground.slideSwitch()){
    alarm_clock();
    delay(500);     
  }
  switch_status = CircuitPlayground.slideSwitch();
  CircuitPlayground.setPixelColor(9, 0x00FF00);   
}
